<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xs="http://www.w3.org/2001/XMLSchema" exclude-result-prefixes="xs"
    xmlns:as="http://www.oasis-open.org/committees/cam"
    xmlns:camed="http://jcam.org.uk/editor"
    xmlns:look="http://jcam.org.uk/LookupLists"
    xmlns:ccl="http://jcam.org.uk/Codelist"
    xmlns:xd="http://www.oxygenxml.com/ns/doc/xsl" version="2.0">
    <xd:doc scope="stylesheet">
        <xd:desc>
            <xd:p><xd:b>Created on:</xd:b> Jan 21, 2011</xd:p>
            <xd:p><xd:b>Author:</xd:b> DRRW</xd:p>
            <xd:p></xd:p>
        </xd:desc>
    </xd:doc>
        
        <!-- Provided "as is" License: Creative Commons - http://creativecommons.org/licenses/by-sa/3.0/
            Author: David RR Webber, January, 2011 -->
        <!--
            Purpose  : Read in Lookup - if its not in CAM format - convert it; return lookup back to Java via stdout. 
            Original : 01/21/2010
            Initials : drrw
            CAM ver    : 1.1 
            Description : Part of a set of tools to provide open source tools for using OASIS CAM lookups.
            Updated  - Inits - Change
            01/21/10   drrw    Initial release
            
        -->
    
    <xsl:variable name="version">1.01</xsl:variable>
    
    <xsl:variable name="chkAltValues" select="count(distinct-values(/ccl:Codelist/Enumeration//ccl:EnumAlternateValue))"/><!-- Default value is None - so see if there are other values -->
    
    <xsl:output method="xml" indent="yes" exclude-result-prefixes="xd xs ccl"/>
    
    <xsl:template match="/">
      
        <xsl:choose>
            <xsl:when test="ccl:Codelist"><xsl:apply-templates mode="IEPD-Factory" select="ccl:Codelist"/></xsl:when>
            <xsl:otherwise><xsl:apply-templates mode="CAM" select="*"/></xsl:otherwise>
        </xsl:choose>   
    </xsl:template>
    
    <xsl:template match="ccl:Codelist" mode="IEPD-Factory">
        <look:LookupList
            name="{@clName}">
                 <xsl:apply-templates select="*" mode="IEPD-Factory"/>
                 <xsl:apply-templates select="text()[1]" mode="IEPD-Factory"/>
             
        </look:LookupList>
    </xsl:template>
    
    <xsl:template match="Enumeration" mode="IEPD-Factory">

            <look:item>
                <xsl:attribute name="name"><xsl:value-of select="ccl:EnumDescription"/></xsl:attribute>
                <xsl:if test="ccl:EnumName"><xsl:attribute name="type"><xsl:value-of select="ccl:EnumName"/></xsl:attribute></xsl:if>
                <xsl:if test="$chkAltValues &gt; 1 and ccl:EnumAlternateValue"><xsl:attribute name="alt"><xsl:value-of select="ccl:EnumAlternateValue"/></xsl:attribute></xsl:if>
                <xsl:value-of select="ccl:EnumValue"/>
            </look:item>

        <!-- Enumeration enumSequence="5">
            <ccl:EnumValue>BL</ccl:EnumValue>
            <ccl:EnumDescription>Black</ccl:EnumDescription>
            <ccl:EnumName>BL</ccl:EnumName>
            <ccl:EnumAlternateValue>None</ccl:EnumAlternateValue>
        </Enumeration -->
    </xsl:template>
    
    <xsl:template match="@*" mode="IEPD-Factory">
        <xsl:copy-of select="."/>
    </xsl:template>
    
    <xsl:template match="*" mode="CAM">
        <xsl:copy>
            <xsl:apply-templates select="@*" mode="CAM"/>
            <xsl:apply-templates select="*" mode="CAM"/>
            <xsl:apply-templates select="text()[1]" mode="CAM"/>
        </xsl:copy>
    </xsl:template>
    
    <xsl:template match="@*" mode="CAM">
        <xsl:copy-of select="."/>
    </xsl:template>
    
</xsl:stylesheet>
